#include <sqlextract/format.h>
#include <sqlextract/filter/arbval.h>
#include <sqlextract/util.h>
#include <stdlib.h>

struct output_formatter_t {
	struct output_formatter_desc_t *desc;
	void *storage;
};

struct output_formatter_t *output_formatter_create(
		struct output_formatter_desc_t *outdesc, void *arg) {
	struct output_formatter_t *outfmt = lf_malloc(
			sizeof(struct output_formatter_t));
	outfmt->desc = outdesc;
	outfmt->storage = (*outfmt->desc->create)(arg);
	return outfmt;
}

void output_formatter_destroy(struct output_formatter_t *outfmt) {
	if(outfmt == NULL)
		return;
	(*outfmt->desc->destroy)(outfmt->storage);
	free(outfmt);
}

void output_formatter_begin(struct output_formatter_t *outfmt) {
	(*outfmt->desc->begin)(outfmt->storage);
}

void output_formatter_end(struct output_formatter_t *outfmt) {
	(*outfmt->desc->end)(outfmt->storage);
}

void output_formatter_row(struct output_formatter_t *outfmt) {
	(*outfmt->desc->row)(outfmt->storage);
}
void output_formatter_field(struct output_formatter_t *outfmt,
		struct arbval_t *value) {
	(*outfmt->desc->field)(outfmt->storage, value);
}
